// Con Clase Febrero 2024
// Ejemplo de documento XHTML nuevo
// Añadir en las opciones de compilador:
// xml2.dll para usar la versión dinámica de libxml2

#include <iostream>
#include <libxml/HTMLtree.h>
#include <cstring>
#include <windows.h>

int main() {
    htmlDocPtr doc;
    xmlNodePtr nodo_raiz, head, body, table, row;

    /*
<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html
     PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
  <head>
    <title>Virtual Library</title>
  </head>
  <body>
    <p>Moved to <a href="http://example.org/">example.org</a>.</p>
  </body>
</html>
    */


    xmlChar DtdID[] = "-//W3C//DTD XHTML 1.0 Strict//EN";
    xmlChar DtdURI[] = "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd";
    xmlChar tagHtml[] = "html";
    xmlChar tagHead[] = "head";
    xmlChar tagTitle[] = "title";
    xmlChar titulo[] = "Informe";
    xmlChar tagBody[] = "body";
    xmlChar tagH1[] = "h1";
    xmlChar tagP[] = "p";
    xmlChar tagTable[] = "table";
    xmlChar tagTableRow[] = "tr";
    xmlChar tagTableHead[] = "th";
    xmlChar tagTableCell[] = "td";

    struct dato {
        char mes[16];
        float cantidad;
    };
    dato data[29] = {
        {"Enero", 23.20},
        {"Febrero", 123.34},
        {"Marzo", 41.21},
        {"Abril", 18.22},
        {"Mayo", 23.2},
        {"Junio", 13.55},
        {"Julio", 3.14},
        {"Agosto", 2.98},
        {"Septiembre", 101.2},
        {"Octubre", 120.47},
        {"Noviembre", 135.56},
        {"Dicimbre", 155.22}
    };
    char cad[32];

    LIBXML_TEST_VERSION;

    // Crear el documento con DTD:
    doc = htmlNewDoc(DtdURI, DtdID);

    // Nodo raíz:
    nodo_raiz = xmlNewDocNode(doc, NULL, tagHtml, NULL);
    xmlDocSetRootElement(doc, nodo_raiz);

    // Añadir atributos:
    xmlNewProp(nodo_raiz, BAD_CAST "lang", BAD_CAST "es");

    // Nodo Head:
    head = xmlNewChild(nodo_raiz, NULL, tagHead, NULL);
    xmlNewChild(head, NULL, tagTitle, titulo);

    // Nodo Body:
    body = xmlNewChild(nodo_raiz, NULL, tagBody, NULL);
    xmlNewChild(body, NULL, tagH1, BAD_CAST "INFORME HTML");
    xmlNewChild(body, NULL, tagP, BAD_CAST "Informe de ventas 2024");
    table = xmlNewChild(body, NULL, tagTable, NULL);
    row = xmlNewChild(table, NULL, tagTableRow, NULL);
    xmlNewChild(row, NULL, tagTableHead, BAD_CAST "Día");
    xmlNewChild(row, NULL, tagTableHead, BAD_CAST "Cantidad");
    for(int i = 0; i<12; i++) {
        row = xmlNewChild(table, NULL, tagTableRow, NULL);
        xmlNewChild(row, NULL, tagTableCell, BAD_CAST data[i].mes);
        sprintf(cad, "%.2f", data[i].cantidad);
        xmlNewChild(row, NULL, tagTableCell, BAD_CAST cad);
    }

    xmlSaveFileEnc("salida.html", doc, "UTF8");
    ShellExecute(NULL, "open", "salida.html", NULL, NULL, SW_SHOWDEFAULT);
    xmlFreeDoc(doc);
    xmlMemoryDump();
    return 0;
}
